struct sentence {
	int s[100];
};

/*@ predicate is_eq(struct sentence q, struct sentence p, int l) = \forall integer i; 0 <= i < l && l < 100 ==> q.s[i] == p.s[i];*/

/*@ requires 1 <= length <= 100;
  @ assigns \nothing;
 */
struct sentence Encrypt(struct sentence Message, int length, int PubKey);

/*@ requires 1 <= length <= 100;
  @ assigns \nothing;
  @ relational \forall struct sentence message,message_beta1,message_beta2,int key,length; is_eq(message_beta2,message_beta1,length)
  ==> (message_beta1 == \callpure(Encrypt,message,length,key) 
  ==> is_eq(\callpure(Decrypt,message_beta2,length,key),message,length));
 */
struct sentence Decrypt(struct sentence Message, int length, int PubKey);

/*@ ensures is_eq(\result,message,len);
  @ assigns \nothing;
*/
struct sentence do_something_with_message(struct sentence message, int len);

/*@ requires 1 <= len <= 100;
  @ ensures is_eq(\result,message,len);*/
struct sentence f(struct sentence message, int len) {
	int key = 120;
	struct sentence ret;

	ret = Encrypt(message,len,key);
	ret = do_something_with_message(ret,len);
	ret = Decrypt(ret,len,key);
	return ret;
}


