/*@ assigns \nothing;
  relational R1: \forall int x1,x2; 
    x1 < x2 ==> \call(f1,x1) < \call(f1,x2);
*/
int f1(int x){
  return x + 1;
}

/*@ assigns \nothing;
  relational R2: \forall int x1, x2; 
    x1 < x2 ==> \call(f2,x1) < \call(f2,x2);
  relational R3: \forall int k; 
    \call(f1,k) < \call(f2,k);
*/
int f2(int y){
  return y + 2;
}

void relational_wrapper(int x1,int x2){
  int tmp1 = 0;
  int tmp2 = 0; 
  tmp1 = x1 + 1; // inlined f1(x1)
  tmp2 = x2 + 1; // inlined f1(x2)
/*@ assert x1 < x2 ==> tmp1 < tmp2; */
}

/*@ axiomatic Relational_axiom{
    logic int f1_acsl(int x);
    lemma Relational_lemma: \forall int x,y; 
      x < y ==> f1_acsl(x) < f1_acsl(y);
    }
*/

/*@ assigns \nothing;
  behavior Relational_behavior:
  ensures \result == f1_acsl(\old(x));
*/
int f1(int x){
  return x + 1;
}

... // similar f${}$or f2
