/*@ relational R1: \forall int x1,x2; 
  x1 < x2 ==> \call(f1,x1) < \call(f1,x2);
*/
int f1(int x);

/*@ relational R2: \forall int x1,x2; 
  x1 < x2 ==> \call(f2,x1) < \call(f2,x2);
*/
int f2(int x);

/*@ relational Rg: \forall int x1,x2; 
  x1 < x2 ==> \call(g,x1) < \call(g,x2);
*/
int g(int x){
  return f1(x)+f2(x);
}

/*@ relational Rh: \forall int x1,x2; 
  x1 < x2 ==> \call(h,x1) < \call(h,x2);
*/
int h(int x){
  return f1(f2(x));
}

void relational_wrapper(int x1,int x2){
  int tmp1 = 0;
  int tmp2 = 0;
  tmp1 = f1(x1) + f2(x1); // g(x1)
  tmp2 = f1(x2) + f2(x2); // g(x2)
/*@ assert x1 < x2 ==> tmp1 < tmp2;*/
}

/*@ axiomatic Relational_axiom{
    logic int g_acsl(int x);
    lemma relational_lemma: \forall int x,y; 
    x < y ==> g_acsl(x) < g_acsl(y);
    }
*/

/*@ behavior Relational_behavior:
  ensures \result == g_acsl(\old(x));
*/
int g(int x){
  return f1(x)+f2(x);
}

... // similar f${}$or h
