struct matrix {
	int m[100];
};
/*@ predicate is_eq_ligne(struct matrix q, struct matrix p, integer l, integer n) = \forall int i; 0 <= i < n && 0 <= l < n && n < 100 ==> q.m[l*n + i] == p.m[l*n+i];*/

/*@ predicate is_trans(struct matrix q, struct matrix p, integer l) = \forall int k,g; 0 <= k < l && 0 <= g < l && l < 100 ==> q.m[g*l + k] == p.m[k*l+g];*/
/*@ predicate is_trans_ligne(struct matrix q, struct matrix p, integer l, integer n) = \forall int k; 0 <= k < n && 0 <= l && l < n < 100 ==> q.m[l*n + k] == p.m[k*n+l];*/
/*@ predicate is_trans_part(struct matrix q, struct matrix p, integer l, integer n) = \forall int k; 0 <= k < l && 0 <= l && l < n < 100 ==> is_trans_ligne(q,p,k,n);*/


/*@ predicate is_eq_part(struct matrix q, struct matrix p, integer l, integer n) = \forall int i; 0 <= i < l && 0 <= l < n && n < 100 ==> is_eq_ligne(q,p,i,n);*/
/*@ predicate is_eq(struct matrix q, struct matrix p, integer l) = \forall int k,g; 0 <= k < l && 0 <= g < l && l < 100 ==> q.m[g*l + k] == p.m[g*l+k];*/


/*@ requires 0 < n <100;
  @ assigns \nothing;
*/
struct matrix trans( struct matrix m, int n){
	int i = 0;
	int j = 0;
	struct matrix m_t;
	/* ... // loop contract
	*/
	for(i = 0; i < n; i++){
	  /* ... // loop contract
	   */
	  for(j = 0; j < n; j++){
	       m_t.m[i*n+j] = m.m[j*n+i];
	  }
	}
	return m_t;
}

/*@ requires 0 < n < 100;
  @ assigns \nothing;
  @ relational \forall struct matrix m1, m2, int n,i; 0 <= i < n && 0 <= n < 100 ==>  is_eq_ligne(\call(trans,\call(sum,m1,m2,n),n), \call(sum,\call(trans,m1,n),\call(trans,m2,n),n),i,n);
*/
struct matrix sum(struct matrix m_a,struct matrix m_b, int n){
  struct matrix m_s;
  int i = 0;
  int b = n*n;
  /* ... // loop contract
  */
  for(i = 0; i < b; i++){
    m_s.m[i] = m_a.m[i] + m_b.m[i];
  }
  return m_s;
}
